<?php

declare(strict_types=1);

namespace App\Modules\LoanPaidOffLetter\Policies;

use App\Modules\LoanPaidOffLetter\Models\LoanPaidOffLetter;
use Illuminate\Auth\Access\HandlesAuthorization;
use Illuminate\Foundation\Auth\User as AuthUser;

class LoanPaidOffLetterPolicy
{
    use HandlesAuthorization;

    public function viewAny(AuthUser $authUser): bool
    {
        return $authUser->can('ViewAny:LoanPaidOffLetter');
    }

    public function view(AuthUser $authUser, LoanPaidOffLetter $loanPaidOffLetter): bool
    {
        return $authUser->can('View:LoanPaidOffLetter');
    }

    public function create(AuthUser $authUser): bool
    {
        return $authUser->can('Create:LoanPaidOffLetter');
    }

    public function update(AuthUser $authUser, LoanPaidOffLetter $loanPaidOffLetter): bool
    {
        return $authUser->can('Update:LoanPaidOffLetter');
    }

    public function delete(AuthUser $authUser, LoanPaidOffLetter $loanPaidOffLetter): bool
    {
        return $authUser->can('Delete:LoanPaidOffLetter');
    }

    public function restore(AuthUser $authUser, LoanPaidOffLetter $loanPaidOffLetter): bool
    {
        return $authUser->can('Restore:LoanPaidOffLetter');
    }

    public function forceDelete(AuthUser $authUser, LoanPaidOffLetter $loanPaidOffLetter): bool
    {
        return $authUser->can('ForceDelete:LoanPaidOffLetter');
    }

    public function forceDeleteAny(AuthUser $authUser): bool
    {
        return $authUser->can('ForceDeleteAny:LoanPaidOffLetter');
    }

    public function restoreAny(AuthUser $authUser): bool
    {
        return $authUser->can('RestoreAny:LoanPaidOffLetter');
    }

    public function replicate(AuthUser $authUser, LoanPaidOffLetter $loanPaidOffLetter): bool
    {
        return $authUser->can('Replicate:LoanPaidOffLetter');
    }

    public function reorder(AuthUser $authUser): bool
    {
        return $authUser->can('Reorder:LoanPaidOffLetter');
    }
}
